"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findLineOffsets = findLineOffsets;
exports.charPosToLineCol = charPosToLineCol;
exports.default = getLinePos;

function findLineOffsets(src) {
  const lf = [0];
  let offset = src.indexOf('\n');

  while (offset !== -1) {
    offset += 1;
    lf.push(offset);
    offset = src.indexOf('\n', offset);
  }

  return lf;
}

function charPosToLineCol(offset, lineOffsets) {
  if (typeof offset === 'number' && offset >= 0 && lineOffsets) {
    for (let i = 0; i < lineOffsets.length; ++i) {
      const start = lineOffsets[i];

      if (offset < start) {
        const line = i - 1;
        return {
          line,
          col: offset - lineOffsets[line]
        };
      }

      if (offset === start) return {
        line: i,
        col: 0
      };
    }
  }

  return {
    line: undefined,
    col: undefined
  };
}

function getLinePos(offset, cstDoc) {
  let lineStarts;

  if (typeof cstDoc === 'string') {
    lineStarts = findLineOffsets(cstDoc);
  } else if (cstDoc.lineStarts) {
    lineStarts = cstDoc.lineStarts;
  } else {//const src =
  }
}